import React, { ReactNode } from "react";

const StarFull = () => {
  return (
    <svg
      width="14"
      height="14"
      viewBox="0 0 42 41"
      fill="none"
      xmlns="http://www.w3.org/2000/svg"
    >
      <path
        d="M20.646 34.6307L9.35258 40.8458C9.20239 40.9272 9.03717 40.9771 8.86701 40.9926C8.69685 41.0081 8.52532 40.9888 8.36287 40.9359C8.20042 40.883 8.05046 40.7976 7.92214 40.685C7.79382 40.5723 7.68982 40.4347 7.61649 40.2806C7.48499 40.017 7.43985 39.7188 7.48745 39.4283L9.64585 26.2629L0.504944 16.9402C0.259478 16.6853 0.12043 16.3466 0.116072 15.993C0.111714 15.6394 0.242373 15.2973 0.481483 15.0365C0.674995 14.8253 0.934484 14.6859 1.21756 14.6411L13.8453 12.7197L19.4935 0.746422C19.5629 0.590436 19.6633 0.450202 19.7888 0.334276C19.9142 0.21835 20.062 0.129162 20.2231 0.0721548C20.3841 0.0151474 20.5552 -0.00848437 20.7257 0.00270111C20.8962 0.0138866 21.0627 0.0596548 21.2149 0.137213C21.4727 0.27105 21.6789 0.486271 21.8015 0.749351L27.4467 12.7256L40.0745 14.6411C40.4224 14.7 40.733 14.8936 40.9389 15.1798C41.1448 15.466 41.2293 15.8218 41.1742 16.17C41.1349 16.4602 41.0033 16.7303 40.7988 16.9402L31.6491 26.2629L33.8075 39.4283C33.8698 39.7726 33.7949 40.1277 33.5988 40.4178C33.4027 40.7078 33.1008 40.9097 32.7576 40.9806C32.4785 41.0305 32.1906 40.9829 31.9424 40.8458L20.646 34.6307Z"
        fill="#F7B500"
      />
    </svg>
  );
};

const StarHalf = () => {
  return (
    <svg
      width="14"
      height="14"
      viewBox="0 0 42 41"
      fill="none"
      xmlns="http://www.w3.org/2000/svg"
    >
      <path
        d="M20.7711 34.1927L20.53 34.06L20.289 34.1927L8.99849 40.4062C8.9981 40.4064 8.99771 40.4066 8.99731 40.4068C8.90709 40.4555 8.8079 40.4854 8.70572 40.4947C8.60309 40.504 8.49965 40.4924 8.4017 40.4605C8.30376 40.4286 8.21338 40.3771 8.13607 40.3093C8.05877 40.2414 7.99616 40.1585 7.95203 40.0658L7.95211 40.0657L7.94792 40.0573C7.86331 39.8878 7.83429 39.696 7.86491 39.5091L10.0233 26.3438L10.0643 26.0938L9.88689 25.9128L0.749138 16.5934C0.748689 16.593 0.748241 16.5925 0.747793 16.592C0.591345 16.4289 0.502849 16.2125 0.500068 15.9868C0.497278 15.7605 0.5809 15.5415 0.734105 15.3743L0.734143 15.3743C0.850927 15.2468 1.00752 15.1625 1.17852 15.1351C1.17896 15.1351 1.17939 15.135 1.17983 15.1349L13.8046 13.214L14.0679 13.174L14.1816 12.933L19.8297 0.959744L19.8299 0.959797L19.8344 0.949611C19.8761 0.855739 19.9366 0.771301 20.0122 0.70147C20.0877 0.631638 20.1768 0.57788 20.2739 0.543508C20.371 0.509137 20.4742 0.494883 20.577 0.501629C20.6792 0.508332 20.779 0.535627 20.8702 0.58184C21.0294 0.664942 21.1566 0.798045 21.2322 0.960465L21.2332 0.962539L26.8785 12.9388L26.9921 13.1799L27.2557 13.2199L39.8788 15.1347C40.0955 15.1724 40.2888 15.2935 40.417 15.4718C40.546 15.6511 40.5989 15.8738 40.5644 16.0917L40.5642 16.0917L40.5627 16.1029C40.5378 16.2866 40.4546 16.4577 40.3251 16.5909C40.325 16.5911 40.3248 16.5913 40.3246 16.5914L31.1763 25.9127L30.9987 26.0936L31.0397 26.3438L33.1981 39.5091L33.1981 39.5092L33.1995 39.5173C33.2386 39.7332 33.1917 39.9558 33.0687 40.1376C32.9469 40.3177 32.7601 40.4438 32.5472 40.4895C32.383 40.5174 32.214 40.4887 32.0682 40.4082L32.0674 40.4078L20.7711 34.1927Z"
        fill="white"
        stroke="#F7B500"
      />
    </svg>
  );
};
const StarDisabled = () => {
  return (
    <svg
      width="14"
      height="14"
      viewBox="0 0 42 41"
      fill="none"
      xmlns="http://www.w3.org/2000/svg"
    >
      <path
        d="M21.0178 34.6307L9.72441 40.8458C9.57421 40.9272 9.409 40.9771 9.23884 40.9926C9.06868 41.0081 8.89714 40.9888 8.73469 40.9359C8.57225 40.883 8.42229 40.7976 8.29396 40.685C8.16564 40.5723 8.06164 40.4347 7.98831 40.2806C7.85681 40.017 7.81167 39.7188 7.85928 39.4283L10.0177 26.2629L0.87677 16.9402C0.631304 16.6853 0.492257 16.3466 0.487899 15.993C0.483541 15.6394 0.6142 15.2973 0.853309 15.0365C1.04682 14.8253 1.30631 14.6859 1.58939 14.6411L14.2171 12.7197L19.8653 0.746422C19.9347 0.590436 20.0352 0.450202 20.1606 0.334276C20.286 0.21835 20.4338 0.129162 20.5949 0.0721548C20.756 0.0151474 20.927 -0.00848437 21.0975 0.00270111C21.2681 0.0138866 21.4345 0.0596548 21.5868 0.137213C21.8445 0.27105 22.0507 0.486271 22.1733 0.749351L27.8185 12.7256L40.4463 14.6411C40.7942 14.7 41.1048 14.8936 41.3107 15.1798C41.5166 15.466 41.6012 15.8218 41.546 16.17C41.5067 16.4602 41.3751 16.7303 41.1706 16.9402L32.0209 26.2629L34.1793 39.4283C34.2417 39.7726 34.1668 40.1277 33.9706 40.4177C33.7745 40.7078 33.4726 40.9097 33.1295 40.9806C32.8503 41.0305 32.5624 40.9829 32.3142 40.8458L21.0178 34.6307Z"
        fill="#E5E5E5"
      />
    </svg>
  );
};

const RatingStars = ({ ratingNumber }: { ratingNumber: number }) => {
  const ceilRating = Math.ceil(ratingNumber);
  const floorRating = Math.floor(ratingNumber);
  const disableCount = 5 - ceilRating;

  let starElements: ReactNode[] = [];

  for (let i = 0; i < floorRating; i++) {
    starElements.push(<StarFull />);
  }
  if (ceilRating - floorRating > 0) {
    starElements.push(<StarHalf />);
  }
  for (let i = 0; i < disableCount; i++) {
    starElements.push(<StarDisabled />);
  }

  return (
    <div
      className="relative inline-block"
      style={{ position: "relative", display: "inline-block" }}
    >
      {starElements.map((el, index) => {
        return (
          <span
            style={{ display: "inline-block", verticalAlign: "middle" }}
            className="inline-block align-middle"
            key={index}
          >
            {el}
          </span>
        );
      })}
      <div
        className="absolute top-0 left-0 whitespace-nowrap overflow-hidden"
        style={{
          width: `${(ratingNumber / 5) * 100}%`,
          position: "absolute",
          top: 0,
          left: 0,
          whiteSpace: "nowrap",
          overflow: "hidden",
        }}
      >
        {Array(5)
          .fill(null)
          .map((_, index) => (
            <span
              key={index}
              className="inline-block align-middle"
              style={{ display: "inline-block", verticalAlign: "middle" }}
            >
              <StarFull />
            </span>
          ))}
      </div>
    </div>
  );
};

export default RatingStars;
